Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4435 2020-03-03 10:38:41Z raasch
 ! bugfix for message that reports about files that are read from in case that the virtual PE grid
 ! has chenged (in case of large number of files format was exceeded), detailed messages about the
@@ -107,4 +110,7 @@
 
     USE averaging
+
+    USE bulk_cloud_model_mod,                                                                      &
+        ONLY:  bulk_cloud_model
 
     USE chem_modules,                                                                              &
@@ -130,4 +136,7 @@
         ONLY:  dx, dy
 
+    USE gust_mod,                                                                                  &
+        ONLY:  gust_module_enabled
+
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nx_on_file, ny, nys, nysg, nyn, &
@@ -146,4 +155,7 @@
         ONLY:  netcdf_precision, output_for_t0
 
+    USE particle_attributes,                                                                       &
+        ONLY:  particle_advection
+
     USE pegrid
 
@@ -156,4 +168,8 @@
     USE random_generator_parallel,                                             &
         ONLY:  id_random_array, seq_random_array
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rd_mpi_io_check_array, rd_mpi_io_close, rd_mpi_io_open, rrd_mpi_io,                 &
+               rrd_mpi_io_global_array
 
     USE spectra_mod,                                                           &
@@ -166,4 +182,7 @@
         ONLY:  statistic_regions, hom, hom_sum, pr_palm, u_max, u_max_ijk,     &
                v_max, v_max_ijk, w_max, w_max_ijk, z_i
+
+    USE user,                                                                                      &
+        ONLY:  user_module_enabled
 
     USE vertical_nesting_mod,                                                  &
@@ -205,12 +224,22 @@
 !> created by PE0 of the previous run
 !------------------------------------------------------------------------------!
-    SUBROUTINE rrd_global
-
-
-       CHARACTER (LEN=10) ::  binary_version_global, version_on_file
-
-       LOGICAL ::  found
-
-
+ SUBROUTINE rrd_global
+
+
+    CHARACTER(LEN=10) ::  binary_version_global  !<
+    CHARACTER(LEN=10) ::  version_on_file        !<
+    CHARACTER(LEN=20) ::  tmp_name               !< temporary variable
+
+    INTEGER ::  i                                !< loop index
+
+    LOGICAL ::  array_found                      !<
+    LOGICAL ::  found                            !<
+
+
+    CALL location_message( 'read global restart data', 'start' )
+
+    IF ( TRIM( restart_data_format_input ) == 'fortran_binary' )  THEN
+!
+!--    Input in Fortran binary format
        CALL check_open( 13 )
 !
@@ -294,8 +323,11 @@
        READ ( 13 )  statistic_regions
 
+!
+!--    The following global arrays (better to say, they have the same size and values on each
+!--    subdomain) are by default allocated in routine parin, but not in case of restarts!
        IF ( .NOT. ALLOCATED( ug ) )  THEN
-          ALLOCATE( ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),                    &
-                    v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),           &
-                    ref_state(0:nz+1), s_init(0:nz+1), sa_init(0:nz+1),        &
+          ALLOCATE( ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),                                        &
+                    v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),                               &
+                    ref_state(0:nz+1), s_init(0:nz+1), sa_init(0:nz+1),                            &
                     hom(0:nz+1,2,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:statistic_regions),  &
                     hom_sum(0:nz+1,pr_palm+max_pr_user+max_pr_cs+max_pr_salsa,0:statistic_regions) )
@@ -617,4 +649,10 @@
              CASE ( 'spinup_time' )
                 READ ( 13 )  spinup_time
+             CASE ( 'subs_vertical_gradient' )
+                READ ( 13 )  subs_vertical_gradient
+             CASE ( 'subs_vertical_gradient_level' )
+                READ ( 13 )  subs_vertical_gradient_level
+             CASE ( 'subs_vertical_gradient_level_i' )
+                READ ( 13 )  subs_vertical_gradient_level_i
              CASE ( 'surface_heatflux' )
                 READ ( 13 )  surface_heatflux
@@ -747,10 +785,4 @@
              CASE ( 'volume_flow_initial' )
                 READ ( 13 )  volume_flow_initial
-             CASE ( 'subs_vertical_gradient' )
-                READ ( 13 )  subs_vertical_gradient
-             CASE ( 'subs_vertical_gradient_level' )
-                READ ( 13 )  subs_vertical_gradient_level
-             CASE ( 'subs_vertical_gradient_level_i' )
-                READ ( 13 )  subs_vertical_gradient_level_i
              CASE ( 'w_max' )
                 READ ( 13 )  w_max
@@ -796,11 +828,326 @@
           READ ( 13 )  restart_string(1:length)
 
+       ENDDO  ! End of loop for reading the restart string
+
+       CALL close_file( 13 )
+
+    ELSEIF ( TRIM( restart_data_format_input ) == 'mpi' )  THEN
+!
+!--    Read global restart data using MPI-IO
+!--    ATTENTION: Arrays need to be read with routine rrd_mpi_io_global_array!
+!--    Caution: When any of the following read instructions have been changed, the
+!--    -------  version number stored in the variable binary_version_global has
+!--             to be increased. The same changes must also be done in
+!--             wrd_write_global.
+!
+!--    Open the MPI-IO restart file.
+       CALL rd_mpi_io_open( 'read', 'BININ', only_global = .TRUE. )
+
+!
+!--    Make version number check first
+       CALL rrd_mpi_io( 'binary_version_global',  version_on_file )
+
+       binary_version_global = '5.0'
+       IF ( TRIM( version_on_file ) /= TRIM( binary_version_global ) )  THEN
+          WRITE( message_string, * ) 'version mismatch concerning binary_version_global:',         &
+                                     '&version on file    = "', TRIM( version_on_file ), '"',      &
+                                     '&version in program = "', TRIM( binary_version_global ), '"'
+          CALL message( 'rrd_global', 'PA0296', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       CALL rrd_mpi_io( 'numprocs',  numprocs_previous_run )
+       CALL rrd_mpi_io( 'nz' , nz )
+       CALL rrd_mpi_io( 'max_pr_user',  max_pr_user )
+       CALL rrd_mpi_io( 'statistic_regions', statistic_regions )
+
+!
+!--    The following global arrays (better to say, they have the same size and values on each
+!--    subdomain) are by default allocated in routine parin, but not in case of restarts!
+       IF ( .NOT. ALLOCATED( ug ) )  THEN
+           ALLOCATE( ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),                                       &
+                     v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),                              &
+                     ref_state(0:nz+1), s_init(0:nz+1), sa_init(0:nz+1),                           &
+                     hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),                        &
+                     hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
+       ENDIF
+
+       CALL rrd_mpi_io( 'advected_distance_x',  advected_distance_x )
+       CALL rrd_mpi_io( 'advected_distance_y', advected_distance_y )
+       CALL rrd_mpi_io( 'alpha_surface', alpha_surface )
+       CALL rrd_mpi_io( 'average_count_pr', average_count_pr )
+       CALL rrd_mpi_io( 'average_count_sp', average_count_sp )
+       CALL rrd_mpi_io( 'average_count_3d', average_count_3d )
+       CALL rrd_mpi_io( 'bc_e_b', bc_e_b )
+       CALL rrd_mpi_io( 'bc_lr', bc_lr )
+       CALL rrd_mpi_io( 'bc_ns', bc_ns )
+       CALL rrd_mpi_io( 'bc_p_b', bc_p_b )
+       CALL rrd_mpi_io( 'bc_p_t', bc_p_t )
+       CALL rrd_mpi_io( 'bc_pt_b', bc_pt_b )
+       CALL rrd_mpi_io( 'bc_pt_t', bc_pt_t )
+       CALL rrd_mpi_io( 'bc_pt_t_val', bc_pt_t_val )
+       CALL rrd_mpi_io( 'bc_q_b', bc_q_b )
+       CALL rrd_mpi_io( 'bc_q_t', bc_q_t )
+       CALL rrd_mpi_io( 'bc_q_t_val', bc_q_t_val )
+       CALL rrd_mpi_io( 'bc_s_b', bc_s_b )
+       CALL rrd_mpi_io( 'bc_s_t', bc_s_t )
+       CALL rrd_mpi_io( 'bc_uv_b', bc_uv_b )
+       CALL rrd_mpi_io( 'bc_uv_t', bc_uv_t )
+       CALL rrd_mpi_io( 'biometeorology', biometeorology )
+       CALL rrd_mpi_io( 'building_height', building_height )
+       CALL rrd_mpi_io( 'building_length_x', building_length_x )
+       CALL rrd_mpi_io( 'building_length_y', building_length_y )
+       CALL rrd_mpi_io( 'building_wall_left', building_wall_left )
+       CALL rrd_mpi_io( 'building_wall_south', building_wall_south )
+       CALL rrd_mpi_io( 'bulk_cloud_model', bulk_cloud_model )
+       CALL rrd_mpi_io( 'call_psolver_at_all_substeps', call_psolver_at_all_substeps )
+       CALL rrd_mpi_io( 'canyon_height', canyon_height )
+       CALL rrd_mpi_io( 'canyon_wall_left', canyon_wall_left )
+       CALL rrd_mpi_io( 'canyon_wall_south', canyon_wall_south )
+       CALL rrd_mpi_io( 'canyon_width_x',  canyon_width_x )
+       CALL rrd_mpi_io( 'canyon_width_y', canyon_width_y )
+       CALL rrd_mpi_io( 'cfl_factor', cfl_factor )
+       CALL rrd_mpi_io( 'cloud_droplets',  cloud_droplets )
+       CALL rrd_mpi_io( 'collective_wait', collective_wait )
+       CALL rrd_mpi_io( 'conserve_volume_flow', conserve_volume_flow )
+       CALL rrd_mpi_io( 'conserve_volume_flow_mode', conserve_volume_flow_mode )
+       CALL rrd_mpi_io( 'constant_flux_layer', constant_flux_layer )
+       CALL rrd_mpi_io( 'coupling_start_time', coupling_start_time )
+       CALL rrd_mpi_io( 'current_timestep_number', current_timestep_number )
+       CALL rrd_mpi_io( 'cycle_mg', cycle_mg )
+       CALL rrd_mpi_io( 'damp_level_1d', damp_level_1d )
+       CALL rrd_mpi_io( 'dissipation_1d', dissipation_1d )
+       CALL rrd_mpi_io_global_array( 'do2d_xy_time_count', do2d_xy_time_count )
+       CALL rrd_mpi_io_global_array( 'do2d_xz_time_count', do2d_xz_time_count )
+       CALL rrd_mpi_io_global_array( 'do2d_yz_time_count', do2d_yz_time_count )
+       CALL rrd_mpi_io_global_array( 'do3d_time_count', do3d_time_count )
+       CALL rrd_mpi_io( 'dp_external', dp_external )
+       CALL rrd_mpi_io( 'dp_level_b', dp_level_b )
+       CALL rrd_mpi_io( 'dp_smooth', dp_smooth )
+       CALL rrd_mpi_io_global_array( 'dpdxy', dpdxy )
+       CALL rrd_mpi_io( 'dt_3d', dt_3d )
+       CALL rrd_mpi_io( 'dt_pr_1d', dt_pr_1d )
+       CALL rrd_mpi_io( 'dt_run_control_1d', dt_run_control_1d )
+       CALL rrd_mpi_io( 'dx', dx )
+       CALL rrd_mpi_io( 'dy', dy )
+       CALL rrd_mpi_io_global_array( 'dz', dz )
+       CALL rrd_mpi_io( 'dz_max', dz_max )
+       CALL rrd_mpi_io( 'dz_stretch_factor', dz_stretch_factor )
+       CALL rrd_mpi_io_global_array( 'dz_stretch_factor_array', dz_stretch_factor_array )
+       CALL rrd_mpi_io( 'dz_stretch_level', dz_stretch_level )
+       CALL rrd_mpi_io_global_array( 'dz_stretch_level_end', dz_stretch_level_end )
+       CALL rrd_mpi_io_global_array( 'dz_stretch_level_start', dz_stretch_level_start )
+       CALL rrd_mpi_io( 'e_min', e_min )
+       CALL rrd_mpi_io( 'end_time_1d', end_time_1d )
+       CALL rrd_mpi_io( 'fft_method', fft_method )
+       CALL rrd_mpi_io( 'first_call_lpm', first_call_lpm )
+       CALL rrd_mpi_io( 'galilei_transformation', galilei_transformation )
+       CALL rrd_mpi_io( 'gust_module_enabled', gust_module_enabled )
+       CALL rrd_mpi_io_global_array( 'hom', hom )
+       CALL rrd_mpi_io_global_array( 'hom_sum', hom_sum )
+       CALL rrd_mpi_io( 'humidity', humidity )
+       CALL rd_mpi_io_check_array( 'inflow_damping_factor', found = array_found )
+       IF ( array_found )  THEN
+           IF ( .NOT. ALLOCATED( inflow_damping_factor ) )  THEN
+               ALLOCATE( inflow_damping_factor(0:nz+1) )
+           ENDIF
+           CALL rrd_mpi_io_global_array( 'inflow_damping_factor', inflow_damping_factor )
+       ENDIF
+       CALL rrd_mpi_io( 'inflow_damping_height', inflow_damping_height )
+       CALL rrd_mpi_io( 'inflow_damping_width', inflow_damping_width )
+       CALL rrd_mpi_io( 'inflow_disturbance_begin', inflow_disturbance_begin )
+       CALL rrd_mpi_io( 'inflow_disturbance_end', inflow_disturbance_end )
+       CALL rrd_mpi_io( 'km_constant', km_constant )
+       CALL rrd_mpi_io( 'large_scale_forcing', large_scale_forcing )
+       CALL rrd_mpi_io( 'large_scale_subsidence', large_scale_subsidence )
+       CALL rrd_mpi_io( 'latitude', latitude )
+       CALL rrd_mpi_io( 'longitude', longitude )
+       CALL rrd_mpi_io( 'loop_optimization', loop_optimization )
+       CALL rrd_mpi_io( 'masking_method', masking_method )
+       CALL rd_mpi_io_check_array( 'mean_inflow_profiles', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( mean_inflow_profiles ) )  THEN
+             ALLOCATE( mean_inflow_profiles(0:nz+1,7) )
+          ENDIF
+          CALL rrd_mpi_io_global_array( 'mean_inflow_profiles', mean_inflow_profiles )
+       ENDIF
+       CALL rrd_mpi_io( 'mg_cycles', mg_cycles )
+       CALL rrd_mpi_io( 'mg_switch_to_pe0_level', mg_switch_to_pe0_level )
+       CALL rrd_mpi_io( 'mixing_length_1d', mixing_length_1d )
+       CALL rrd_mpi_io( 'momentum_advec', momentum_advec )
+!
+!--    There is no module procedure for CHARACTER arrays
+       DO  i = 1, SIZE( netcdf_precision , 1 )
+          WRITE( tmp_name, '(A,I2.2)' )  'netcdf_precision_', i
+          CALL rrd_mpi_io( TRIM( tmp_name ), netcdf_precision(i) )
        ENDDO
-
-
-    CALL close_file( 13 )
-
-
-    END SUBROUTINE rrd_global
+       CALL rrd_mpi_io( 'neutral', neutral )
+       CALL rrd_mpi_io( 'ngsrb', ngsrb )
+       CALL rrd_mpi_io( 'nsor', nsor )
+       CALL rrd_mpi_io( 'nsor_ini', nsor_ini )
+       CALL rrd_mpi_io( 'nudging', nudging )
+       CALL rrd_mpi_io( 'num_leg', num_leg )
+       CALL rrd_mpi_io( 'nx', nx )
+       nx_on_file = nx
+       CALL rrd_mpi_io( 'ny', ny )
+       ny_on_file = ny
+       CALL rrd_mpi_io( 'ocean_mode', ocean_mode )
+       CALL rrd_mpi_io( 'omega', omega )
+       CALL rrd_mpi_io( 'omega_sor', omega_sor )
+       CALL rrd_mpi_io( 'origin_data_time', origin_date_time )
+       CALL rrd_mpi_io( 'output_for_t0', output_for_t0 )
+       CALL rrd_mpi_io( 'particle_advection', particle_advection )
+       CALL rrd_mpi_io( 'passive_scalar', passive_scalar )
+       CALL rrd_mpi_io( 'prandtl_number', prandtl_number )
+       CALL rrd_mpi_io( 'psolver', psolver )
+       CALL rrd_mpi_io( 'pt_damping_factor', pt_damping_factor )
+       CALL rrd_mpi_io( 'pt_damping_width', pt_damping_width )
+       CALL rrd_mpi_io_global_array( 'pt_init', pt_init )
+       CALL rrd_mpi_io( 'pt_reference', pt_reference )
+       CALL rrd_mpi_io( 'pt_surface', pt_surface )
+       CALL rrd_mpi_io( 'pt_surface_initial_change', pt_surface_initial_change )
+       CALL rrd_mpi_io_global_array( 'pt_vertical_gradient', pt_vertical_gradient )
+       CALL rrd_mpi_io_global_array( 'pt_vertical_gradient_level', pt_vertical_gradient_level )
+       CALL rrd_mpi_io_global_array( 'pt_vertical_gradient_level_ind', pt_vertical_gradient_level_ind )
+       CALL rrd_mpi_io_global_array( 'q_init', q_init )
+       CALL rrd_mpi_io( 'q_surface', q_surface )
+       CALL rrd_mpi_io( 'q_surface_initial_change', q_surface_initial_change )
+       CALL rrd_mpi_io_global_array( 'q_vertical_gradient', q_vertical_gradient )
+       CALL rrd_mpi_io_global_array( 'q_vertical_gradient_level', q_vertical_gradient_level )
+       CALL rrd_mpi_io_global_array( 'q_vertical_gradient_level_ind', q_vertical_gradient_level_ind )
+       CALL rrd_mpi_io( 'random_generator', random_generator )
+       CALL rrd_mpi_io( 'random_heatflux', random_heatflux )
+       CALL rrd_mpi_io( 'rans_mode', rans_mode )
+       CALL rrd_mpi_io( 'rayleigh_damping_factor', rayleigh_damping_factor )
+       CALL rrd_mpi_io( 'rayleigh_damping_height', rayleigh_damping_height )
+       CALL rrd_mpi_io( 'recycling_width', recycling_width )
+       CALL rrd_mpi_io_global_array( 'ref_state', ref_state )
+       CALL rrd_mpi_io( 'reference_state', reference_state )
+       CALL rrd_mpi_io( 'residual_limit', residual_limit )
+       CALL rrd_mpi_io( 'roughness_length', roughness_length )
+       CALL rrd_mpi_io( 'run_coupled', run_coupled )
+       CALL rrd_mpi_io( 'runnr', runnr )
+       CALL rrd_mpi_io_global_array( 's_init', s_init )
+       CALL rrd_mpi_io( 's_surface', s_surface )
+       CALL rrd_mpi_io( 's_surface_initial_change', s_surface_initial_change )
+       CALL rrd_mpi_io_global_array( 's_vertical_gradient', s_vertical_gradient )
+       CALL rrd_mpi_io_global_array( 's_vertical_gradient_level', s_vertical_gradient_level )
+       CALL rrd_mpi_io_global_array( 's_vertical_gradient_level_ind', s_vertical_gradient_level_ind )
+       CALL rrd_mpi_io( 'scalar_advec', scalar_advec )
+       CALL rrd_mpi_io( 'simulated_time', simulated_time )
+       CALL rd_mpi_io_check_array( 'spectrum_x', found = array_found )
+       IF (array_found )  THEN
+           IF ( .NOT. ALLOCATED( spectrum_x ) )  THEN
+              ALLOCATE( spectrum_x( 1:nx/2, 1:100, 1:10 ) )
+           ENDIF
+           CALL rrd_mpi_io( 'spectrum_y', spectrum_y )
+       ENDIF
+       CALL rd_mpi_io_check_array( 'spectrum_y', found = array_found )
+       IF ( array_found )  THEN
+           IF ( .NOT. ALLOCATED( spectrum_y ) )  THEN
+              ALLOCATE( spectrum_y( 1:ny/2, 1:100, 1:10 ) )
+           ENDIF
+           CALL rrd_mpi_io( 'spectrum_y', spectrum_y )
+       ENDIF
+       CALL rrd_mpi_io( 'spinup_time ', spinup_time )
+       CALL rrd_mpi_io_global_array( 'subs_vertical_gradient', subs_vertical_gradient )
+       CALL rrd_mpi_io_global_array( 'subs_vertical_gradient_level', subs_vertical_gradient_level )
+       CALL rrd_mpi_io_global_array( 'subs_vertical_gradient_level_i', subs_vertical_gradient_level_i )
+       CALL rrd_mpi_io( 'surface_heatflux', surface_heatflux )
+       CALL rrd_mpi_io( 'surface_pressure', surface_pressure )
+       CALL rrd_mpi_io( 'surface_output', surface_output )
+       CALL rrd_mpi_io( 'surface_scalarflux', surface_scalarflux )
+       CALL rrd_mpi_io( 'surface_waterflux', surface_waterflux )
+       CALL rrd_mpi_io( 'syn_turb_gen', syn_turb_gen )
+       CALL rrd_mpi_io( 'time_coupling', time_coupling )
+       CALL rrd_mpi_io( 'time_disturb', time_disturb )
+       CALL rrd_mpi_io( 'time_do2d_xy', time_do2d_xy )
+       CALL rrd_mpi_io( 'time_do2d_xz', time_do2d_xz )
+       CALL rrd_mpi_io( 'time_do2d_yz', time_do2d_yz )
+       CALL rrd_mpi_io( 'time_do3d', time_do3d )
+       CALL rrd_mpi_io( 'time_do_av', time_do_av )
+       CALL rrd_mpi_io( 'time_do_sla', time_do_sla )
+       CALL rrd_mpi_io_global_array( 'time_domask', time_domask )
+       CALL rrd_mpi_io( 'time_dopr', time_dopr )
+       CALL rrd_mpi_io( 'time_dopr_av', time_dopr_av )
+       CALL rrd_mpi_io( 'time_dopr_listing', time_dopr_listing )
+       CALL rrd_mpi_io( 'time_dopts', time_dopts )
+       CALL rrd_mpi_io( 'time_dosp', time_dosp )
+       CALL rrd_mpi_io( 'time_dots', time_dots )
+       CALL rrd_mpi_io( 'time_radiation', time_radiation )
+       CALL rrd_mpi_io( 'time_restart', time_restart )
+       CALL rrd_mpi_io( 'time_run_control', time_run_control )
+       CALL rrd_mpi_io( 'time_since_reference_point', time_since_reference_point )
+       CALL rrd_mpi_io( 'time_virtual_measurement', time_virtual_measurement )
+       CALL rrd_mpi_io( 'timestep_scheme', timestep_scheme )
+       CALL rrd_mpi_io( 'top_heatflux', top_heatflux )
+       CALL rrd_mpi_io( 'top_momentumflux_u', top_momentumflux_u )
+       CALL rrd_mpi_io( 'top_momentumflux_v', top_momentumflux_v )
+       CALL rrd_mpi_io( 'top_scalarflux', top_scalarflux )
+       CALL rrd_mpi_io( 'topography', topography )
+       CALL rrd_mpi_io( 'topography_grid_convention', topography_grid_convention )
+       CALL rrd_mpi_io_global_array( 'tsc', tsc )
+       CALL rrd_mpi_io( 'tunnel_height', tunnel_height )
+       CALL rrd_mpi_io( 'tunnel_length', tunnel_length )
+       CALL rrd_mpi_io( 'tunnel_wall_depth', tunnel_wall_depth )
+       CALL rrd_mpi_io( 'tunnel_width_x', tunnel_width_x )
+       CALL rrd_mpi_io( 'tunnel_width_y', tunnel_width_y )
+       CALL rrd_mpi_io( 'turbulence_closure', turbulence_closure )
+       CALL rrd_mpi_io( 'turbulent_inflow', turbulent_inflow )
+       CALL rrd_mpi_io( 'u_bulk', u_bulk )
+       CALL rrd_mpi_io_global_array( 'u_init', u_init )
+       CALL rrd_mpi_io( 'u_max', u_max )
+       CALL rrd_mpi_io_global_array( 'u_max_ijk', u_max_ijk )
+       CALL rrd_mpi_io_global_array( 'ug', ug )
+       CALL rrd_mpi_io( 'ug_surface', ug_surface )
+       CALL rrd_mpi_io_global_array( 'ug_vertical_gradient', ug_vertical_gradient )
+       CALL rrd_mpi_io_global_array( 'ug_vertical_gradient_level', ug_vertical_gradient_level )
+       CALL rrd_mpi_io_global_array( 'ug_vertical_gradient_level_ind', ug_vertical_gradient_level_ind )
+       CALL rrd_mpi_io( 'use_surface_fluxes', use_surface_fluxes )
+       CALL rrd_mpi_io( 'use_top_fluxes', use_top_fluxes )
+       CALL rrd_mpi_io( 'use_ug_for_galilei_tr', use_ug_for_galilei_tr )
+       CALL rrd_mpi_io( 'use_upstream_for_tke', use_upstream_for_tke )
+       CALL rrd_mpi_io( 'user_module_enabled', user_module_enabled )
+       CALL rrd_mpi_io( 'v_bulk', v_bulk )
+       CALL rrd_mpi_io_global_array( 'v_init', v_init )
+       CALL rrd_mpi_io( 'v_max', v_max )
+       CALL rrd_mpi_io_global_array( 'v_max_ijk', v_max_ijk )
+       CALL rrd_mpi_io_global_array( 'vg', vg )
+       CALL rrd_mpi_io( 'vg_surface', vg_surface )
+       CALL rrd_mpi_io_global_array( 'vg_vertical_gradient', vg_vertical_gradient )
+       CALL rrd_mpi_io_global_array( 'vg_vertical_gradient_level', vg_vertical_gradient_level )
+       CALL rrd_mpi_io_global_array( 'vg_vertical_gradient_level_ind', vg_vertical_gradient_level_ind )
+       CALL rrd_mpi_io( 'virtual_flight', virtual_flight )
+       CALL rrd_mpi_io( 'vnest_init', vnest_init )
+       CALL rrd_mpi_io_global_array( 'volume_flow_area', volume_flow_area )
+       CALL rrd_mpi_io_global_array( 'volume_flow_initial', volume_flow_initial )
+       CALL rrd_mpi_io( 'w_max', w_max )
+       CALL rrd_mpi_io_global_array( 'w_max_ijk', w_max_ijk )
+       CALL rrd_mpi_io( 'wall_adjustment', wall_adjustment )
+       CALL rrd_mpi_io_global_array( 'wall_heatflux', wall_heatflux )
+       CALL rrd_mpi_io_global_array( 'wall_humidityflux', wall_humidityflux )
+       CALL rrd_mpi_io_global_array( 'wall_scalarflux', wall_scalarflux )
+       CALL rrd_mpi_io( 'y_shift', y_shift )
+       CALL rrd_mpi_io( 'z0h_factor', z0h_factor )
+       CALL rrd_mpi_io( 'zeta_max', zeta_max )
+       CALL rrd_mpi_io( 'zeta_min', zeta_min )
+       CALL rrd_mpi_io_global_array( 'z_i', z_i )
+
+!
+!--    Read global variables from of other modules
+       CALL module_interface_rrd_global
+
+!
+!--    Close restart File
+       CALL rd_mpi_io_close
+
+#if defined( __parallel )
+       CALL MPI_BARRIER( MPI_COMM_WORLD, ierr )
+#endif
+
+    ENDIF
+
+    CALL location_message( 'read global restart data', 'finished' )
+
+ END SUBROUTINE rrd_global
 
 
@@ -1895,27 +2242,26 @@
 !> Skipping the global control variables from restart-file (binary format)
 !------------------------------------------------------------------------------!
-
-    SUBROUTINE rrd_skip_global
-
-
-       CHARACTER (LEN=1) ::  cdum
-
-
+ SUBROUTINE rrd_skip_global
+
+
+    CHARACTER (LEN=1) ::  cdum
+
+
+    READ ( 13 )  length
+    READ ( 13 )  restart_string(1:length)
+
+    DO  WHILE ( restart_string(1:length) /= 'binary_version_local' )
+
+       READ ( 13 )  cdum
        READ ( 13 )  length
        READ ( 13 )  restart_string(1:length)
 
-       DO  WHILE ( restart_string(1:length) /= 'binary_version_local' )
-
-          READ ( 13 )  cdum
-          READ ( 13 )  length
-          READ ( 13 )  restart_string(1:length)
-
-       ENDDO
-
-       BACKSPACE ( 13 )
-       BACKSPACE ( 13 )
-
-
-    END SUBROUTINE rrd_skip_global
+    ENDDO
+
+    BACKSPACE ( 13 )
+    BACKSPACE ( 13 )
+
+
+ END SUBROUTINE rrd_skip_global
 
 
